# https://github.com/google/protobuf/archive/v3.5.2.tar.gz

%define major 23
%define libname	   %mklibname %{name} %{major}
%define libnamedev %mklibname %{name} -d

Name:		        protobuf
Version:	      3.12.4
Release:	      %mkrel 3
Summary:        Protocol Buffers - Google's data interchange format
Summary(de):    Protocol Buffers - Googles Datenaustauschformat

License:	      new BSD
Group:		      Networking/Other
URL:		        https://developers.google.com/protocol-buffers/
Source0:	      %{name}-%{version}-all.tar.xz

BuildRequires:	zlib-devel
BuildRequires:  python-devel
BuildRequires:  python-setuptools
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools

Obsoletes: kismet = 2019.08.R1

%description
Protocol Buffers are a way of encoding structured data in an efficient
yet extensible format. Google uses Protocol Buffers for almost all of
its internal RPC protocols and file formats.

%description -l de
Protocol Buffers sind ein Weg zum Kodieren von strukturierten Daten, in
einem effizienten jedoch erweiterbaren Format. Google nutzt Protocol
Buffers für fast alle seine internen RPC Protokolle und Dateiformate.

%package -n %{libname}
Summary:	      Protocol Buffers - Google's data interchange format
Summary(de):	  Protocol Buffers - Googles Datenaustauschformat
Group:		      Networking/Other
License:	      new BSD
Provides:	      lib%{name} = %{version}-%{release}
Provides:	      %{_lib}%{name}-lite%{major} = %{version}-%{release}
Provides:	      lib%{name}-lite = %{version}-%{release}
Provides:	      protobuf = %{version}-%{release}
Provides:	      protobuf-compiler = %{version}-%{release}
Obsoletes:      protobuf < %{version}
Obsoletes:      protobuf-compiler < %{version}
Obsoletes:      lib64protobuf22
Obsoletes:      lib64protobuf15
Obsoletes:      lib64protobuf8
Requires:        %{name}

%description -n %{libname}
Protocol Buffers are a way of encoding structured data in an efficient
yet extensible format. Google uses Protocol Buffers for almost all of
its internal RPC protocols and file formats.

%description -n %{libname} -l de
Protocol Buffers sind ein Weg zum Kodieren von strukturierten Daten, in
einem effizienten jedoch erweiterbaren Format. Google nutzt Protocol
Buffers für fast alle seine internen RPC Protokolle und Dateiformate.

%package -n %{libnamedev}
Summary:	      Protocol Buffers - Google's data interchange format
Summary(de):	  Protocol Buffers - Googles Datenaustauschformat
Group:		      Networking/Other
License:	      new BSD
Requires:	      %{libname} = %{version}-%{release}
Provides:	      %{_lib}%{name}-lite-devel = %{version}-%{release}
Provides:       protobuf-devel = %{version}-%{release}
Obsoletes:	    protobuf-devel < %{version}

%description -n %{libnamedev}
Protocol Buffers are a way of encoding structured data in an efficient
yet extensible format. Google uses Protocol Buffers for almost all of
its internal RPC protocols and file formats.

This package contains the development headers and libraries for
protobuf.

%description -n %{libnamedev} -l de
Protocol Buffers sind ein Weg zum Kodieren von strukturierten Daten, in
einem effizienten jedoch erweiterbaren Format. Google nutzt Protocol
Buffers für fast alle seine internen RPC Protokolle und Dateiformate.

Dieses Paket enthält die Header-Dateien und Bibliotheken für protobuf.

%package -n     python-%{name}
Summary:        Python bindings for Google Protocol Buffers
Group:          Development/Python
BuildRequires:  python-devel
BuildRequires:  python-setuptools
Provides:       %{name}-python = %{version}-%{release}

%description -n python-%{name}
This package contains Python libraries for Google Protocol Buffers.

%package -n     python3-%{name}
Summary:        Python3 bindings for Google Protocol Buffers
Group:          Development/Python
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
Provides:       %{name}-python3 = %{version}-%{release}

%description -n python3-%{name}
This package contains Python3 libraries for Google Protocol Buffers.

%prep
%setup -q
find -name \*.cc -o -name \*.h | xargs chmod -x
%__chmod 644 examples/*

%build
export PTHREAD_LIBS=-lpthread
./autogen.sh
%configure2_5x --disable-static
%make_build

pushd python
%py2_build
%py3_build
sed -i -e 1d build/lib/google/protobuf/descriptor_pb2.py
popd

%install
%makeinstall_std
find %{buildroot} -name '*.la' -delete

pushd python
%py2_install
%py3_install
popd

%files
%defattr(-,root,root)
%{_bindir}/protoc

%files -n %{libname}
%defattr(-,root,root)
%{_bindir}/protoc
%{_libdir}/lib%{name}.so.%{major}*
%{_libdir}/lib%{name}-lite.so.%{major}*
%{_libdir}/libprotoc.so.%{major}*

%files -n %{libnamedev}
%defattr(-,root,root)
%{_includedir}/google
%{_libdir}/lib%{name}.so
%{_libdir}/lib%{name}-lite.so
%{_libdir}/libprotoc.so
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/pkgconfig/%{name}-lite.pc

%files -n python-%{name}
%{python_sitelib}/*
%doc python/README.md examples/{*.py,addressbook.proto}

%files -n python3-%{name}
%{python3_sitelib}/*
%doc python/README.md examples/{*.py,addressbook.proto}

%changelog
* Wed Jun 29 2022 TerryN <terryn94 at gmail.com> 3.12.4-3pclos2022
- rebuild for python 3.10

* Sun Oct 03 2021 tex - 3.12.4-2pclos2021
 - obsolete lib64protobuf22

* Wed Sep 29 2021 tex - 3.12.4-1pclos2021
- new version

* Sat May 02 2020 tex - 3.11.4-1pclos2020
- new version

* Sat Apr 18 2020 tex - 3.11.2-2pclos2020
- obsolete lib64protobuf15

* Sun Apr 15 2018 marcin82 <fixxer1982 at gmail.com> 3.5.2-1pclos2018
- update

* Mon Aug 21 2017 bb2 <bb2> - 3.3.1-1pclos2017
- new version
- add python3 build

* Thu Jun 29 2017 bb2 <bb2> - 3.1.0-3pclos2017
- rebuild without any lib64protobuf-devel installed

* Tue May 23 2017 bb2 <bb2> - 3.1.0-2pclos2017
- add python package

* Sat Jan 28 2017 marcin82 <marcin82 at vp.pl> - 3.1.0-1pclos2017
- update
- updated project url, changes in spec file

* Sun May 12 2013 Texstar <texstar at gmail.com> - 2.5.0-4pclos2013
- add more obsoletes
